/*****************************************************************************/
/* XBalloon - Balloons move on root window.                                  */
/*                                                                           */
/* XBalloon Copyright (c) 1999 Sakai Hiroaki.                                */
/* All Rights Reserved.                                                      */
/*                                                                           */
/* XBalloon is a simple demonstration program for X. Balloons move on root   */
/* window. You can use a faborite pixmap as balloons.                        */
/*                                                                           */
/* XBalloon is a free software. You may copy or distribute the original      */
/* XBalloon freely. But, you may not modify or distribute the original       */
/* XBalloon without permission of the author.                                */
/*****************************************************************************/

/*****************************************************************************/
/* Include Header Files.                                                     */
/*****************************************************************************/

#include "display.h"

/*****************************************************************************/
/* Definitions of Functions.                                                 */
/*****************************************************************************/

void InitializeDisplay()
{
  xballoon.display = XOpenDisplay(xballoon.display_name);
  xballoon.screen = DefaultScreen(xballoon.display);
  xballoon.colormap = DefaultColormap(xballoon.display, xballoon.screen);
  xballoon.width  =  DisplayWidth(xballoon.display, xballoon.screen);
  xballoon.height = DisplayHeight(xballoon.display, xballoon.screen);
  xballoon.root_window = RootWindow(xballoon.display, xballoon.screen);
  xballoon.depth = DefaultDepth(xballoon.display, xballoon.screen);
  if (xballoon.balloon_pixmap_filename == NULL)
    xballoon.balloon_pixmap = 
      MakePixmapFromData(xballoon.display, xballoon.root_window, balloon,
			 &(xballoon.balloon_width),
			 &(xballoon.balloon_height));
  else
    xballoon.balloon_pixmap = 
      MakePixmapFromFile(xballoon.display, xballoon.root_window,
			 xballoon.balloon_pixmap_filename,
			 &(xballoon.balloon_width),
			 &(xballoon.balloon_height));
  xballoon.balloon_figure =
    MakePixmapFigure(xballoon.display, xballoon.root_window,
		     xballoon.balloon_pixmap,
		     xballoon.balloon_width, xballoon.balloon_height,
		     xballoon.depth);
}

/*****************************************************************************/
/* End of XBalloon                                                           */
/*****************************************************************************/
