/*****************************************************************************/
/* XBalloon - Balloons move on root window.                                  */
/*                                                                           */
/* XBalloon Copyright (c) 1999 Sakai Hiroaki.                                */
/* All Rights Reserved.                                                      */
/*                                                                           */
/* XBalloon is a simple demonstration program for X. Balloons move on root   */
/* window. You can use a faborite pixmap as balloons.                        */
/*                                                                           */
/* XBalloon is a free software. You may copy or distribute the original      */
/* XBalloon freely. But, you may not modify or distribute the original       */
/* XBalloon without permission of the author.                                */
/*****************************************************************************/

/*****************************************************************************/
/* Include Header Files.                                                     */
/*****************************************************************************/

#include "graphic.h"

/*****************************************************************************/
/* Definitions of Functions.                                                 */
/*****************************************************************************/

Pixmap MakePixmapFromFile(Display * display, Window w, char * filename,
                          int * width, int * height)
{
  XpmAttributes attributes;
  Pixmap pix, mask;

  attributes.colormap = DefaultColormap(display, DefaultScreen(display));
  attributes.closeness = 40000;
  attributes.valuemask = XpmSize|XpmReturnPixels|XpmColormap|XpmCloseness;
  XpmReadFileToPixmap(display, w, filename, &pix, &mask, &attributes);
  *width  = attributes.width;
  *height = attributes.height;
  return (pix);
}

Pixmap MakePixmapFromData(Display * display, Window w, char * string[],
                          int * width, int * height)
{
  XpmAttributes attributes;
  Pixmap pix, mask;

  attributes.colormap = DefaultColormap(display, DefaultScreen(display));
  attributes.closeness = 40000;
  attributes.valuemask = XpmSize|XpmReturnPixels|XpmColormap|XpmCloseness;
  XpmCreatePixmapFromData(display, w, string, &pix, &mask, &attributes);
  *width  = attributes.width;
  *height = attributes.height;
  return (pix);
}

Pixmap MakePixmapFigure(Display * display, Drawable da,
			Pixmap source, int w, int h, int d)
{
  Pixmap figure;
  GC gc;
  int i;
  unsigned long a;

  figure = XCreatePixmap(display, da, w, h, d);
  gc = XCreateGC(display, da, 0, NULL);
  XSetForeground(display, gc, 0xffffffff);
  XSetBackground(display, gc, 0x00000000);
  XSetFunction(display, gc, GXcopy);
  XCopyArea(display, source, figure, gc, 0, 0, w, h, 0, 0);
  XSetFunction(display, gc, GXor);
  a = 1;
  for (i = 0; i < d; i++, a *= 2)
    XCopyPlane(display, source, figure, gc, 0, 0, w, h, 0, 0, a);
  XFreeGC(display, gc);
  return (figure);
}

/*****************************************************************************/
/* End of XBalloon.                                                          */
/*****************************************************************************/
