/*****************************************************************************/
/* XBalloon - Balloons move on root window.                                  */
/*                                                                           */
/* XBalloon Copyright (c) 1999 Sakai Hiroaki.                                */
/* All Rights Reserved.                                                      */
/*                                                                           */
/* XBalloon is a simple demonstration program for X. Balloons move on root   */
/* window. You can use a faborite pixmap as balloons.                        */
/*                                                                           */
/* XBalloon is a free software. You may copy or distribute the original      */
/* XBalloon freely. But, you may not modify or distribute the original       */
/* XBalloon without permission of the author.                                */
/*****************************************************************************/

/*****************************************************************************/
/* Include Header Files.                                                     */
/*****************************************************************************/

#include "init.h"

/*****************************************************************************/
/* Definitions of Functions.                                                 */
/*****************************************************************************/

void MakeBalloon(int i)
{
  balloons.point[i].x = (xballoon.width - xballoon.balloon_width) / 2;
  balloons.point[i].y = (xballoon.height - xballoon.balloon_height) / 2;
  do {
    do {
      balloons.velocity[i].x =
	(rand() % (balloons.velocity_maximum*2+1)) - balloons.velocity_maximum;
    } while (balloons.velocity[i].x == 0);
    do {
      balloons.velocity[i].y =
	(rand() % (balloons.velocity_maximum*2+1)) - balloons.velocity_maximum;
    } while (balloons.velocity[i].y == 0);
  } while (balloons.velocity[i].x * balloons.velocity[i].x +
	   balloons.velocity[i].y * balloons.velocity[i].y <
	   balloons.velocity_minimum * balloons.velocity_minimum);
  do {
    balloons.speed[i] = (rand() % balloons.speed_maximum) + 1;
  } while (balloons.speed[i] < balloons.speed_minimum);
  balloons.count[i] = 0;
}

void InitializeBalloon()
{
  int i;
  srand((unsigned)time(NULL));
  balloons.point     = (XPoint *)malloc(sizeof(XPoint) * balloons.number);
  balloons.point_old = (XPoint *)malloc(sizeof(XPoint) * balloons.number);
  balloons.velocity  = (XPoint *)malloc(sizeof(XPoint) * balloons.number);
  balloons.speed = (int  *)malloc(sizeof(int) * balloons.number);
  balloons.count = (int  *)malloc(sizeof(int) * balloons.number);
  for (i = 0; i < balloons.number; i++) MakeBalloon(i);
}

/*****************************************************************************/
/* End of XBalloon.                                                          */
/*****************************************************************************/
