/*****************************************************************************/
/* XBalloon - Balloons move on root window.                                  */
/*                                                                           */
/* XBalloon Copyright (c) 1999 Sakai Hiroaki.                                */
/* All Rights Reserved.                                                      */
/*                                                                           */
/* XBalloon is a simple demonstration program for X. Balloons move on root   */
/* window. You can use a faborite pixmap as balloons.                        */
/*                                                                           */
/* XBalloon is a free software. You may copy or distribute the original      */
/* XBalloon freely. But, you may not modify or distribute the original       */
/* XBalloon without permission of the author.                                */
/*****************************************************************************/

#ifndef _XBALLOON_XBALLOON_H_INCLUDED_
#define _XBALLOON_XBALLOON_H_INCLUDED_

/*****************************************************************************/
/* Include Header Files.                                                     */
/*****************************************************************************/

#include <X11/Xlib.h>

#include "configure.h"

/*****************************************************************************/
/* Difinitions of Some Structures.                                           */
/*****************************************************************************/

typedef struct XBalloon {
  Display * display;
  int screen;
  Colormap colormap;
  int width, height, depth;
  Window root_window;
  char * display_name;
  Pixmap balloon_pixmap, balloon_figure;
  int balloon_width, balloon_height;
  char * balloon_pixmap_filename;
  int wait;
} XBalloon;

typedef struct Balloon {
  int number, count_maximum;
  int speed_maximum, speed_minimum, velocity_maximum, velocity_minimum;
  XPoint * point;
  XPoint * point_old;
  XPoint * velocity;
  int * speed;
  int * count;
} Balloon;

/*****************************************************************************/
/* Difinitions of Some Parameters                                            */
/*****************************************************************************/

extern XBalloon xballoon;
extern Balloon balloons;

#endif

/*****************************************************************************/
/* End of XBalloon.                                                          */
/*****************************************************************************/
